#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define MAX 17
#define COUNT 12

int sort (int *arr, int n) {
     int swaped,i,j,tmp,cnt=0;
     for (i=n-1; i>0; i--) {
         swaped = 0;
         for (j=0; j<i; j++) {
             if (arr[j] > arr[j+1]) {
                swaped=1;
                tmp = arr[j];
                arr[j]=arr[j+1];
                arr[j+1]=tmp;
                cnt++;          
             }
         }
         if (swaped == 0)
            break;
     }
     return cnt;
}

int main () {
     int *polinomai = malloc(sizeof(int)*COUNT);
     if (polinomai == NULL) {
        printf("Klaida isskiriant atminti.");
        return 0;
     }
     FILE *output;
     int i,cnt,n,swaped,kof;
     int seed = time(0);
     srand(seed);
     printf("Seed for rand() = %d\n",seed);
     printf("\nSugeneruoti atsitiktiniai polinomu laipsniai:\n");
     for (n=0; n< COUNT; n++) {
        polinomai[n] = rand() % (MAX+1);
     }
     for (i=0; i<n; i++) {
             printf("%d\n",polinomai[i]);  
     }
     printf("\nSurikiuoti polinomu laipsniai:\n");
     cnt = sort (polinomai, n);
     for (i=0; i<n; i++) {
             printf("%d\n",polinomai[i]);  
     }
     printf("\nSwap skaicius = %d\n\n",cnt);
     printf("\nSurikiuotas polinomas faile out");
	 kof = 1;
     output=fopen("out.txt", "w"); 
	 for (i=0; i<n; i++) {
         if (polinomai[i]==polinomai[i+1]) {
            kof++;                                  
         } else {
			if ((kof > 1) && (polinomai[i]>0)) {
				fprintf(output,"%d",kof);
			}
			if (polinomai[i]>0) {
				fprintf(output,"x");
			}
			if (polinomai[i] > 1) {
				fprintf(output,"^%d",polinomai[i]);
			}
			if (i < n-1)
				fprintf(output,"+");
			kof = 1;
         }
     }
     
     //fprintf(output,"%d",cnt);
     fclose(output);
     getchar();     
}
